#include "sighand.h"   /* itime() */
#include "spins.h"

/* nr=0,1,2,... -1=close, v2.20 less sys-calls */
void outtri(int nr,zahl a,zahl b){ /* Ausgabe Tridiagonalmatrixelemente */
    static FILE *ft=NULL, *fb=NULL;
    long t=itime();
    if (nr<=0) {
      if (ft) fclose(ft); if (fb) fclose(fb); ft=fb=NULL; if (nr<0) return;
    }
    if (!ft) {
      ft=fopen("tmp/tri.txt","wt"); setvbuf(ft,NULL,_IONBF,0);
      fb=fopen("tmp/tri.dat","wb"); setvbuf(fb,NULL,_IONBF,0);
      if (!ft) { E0("fopen tmp/tri.txt"); return; }
      if (!fb) { E0("fopen tmp/tri.txt"); return; }
    }
    /* 0..960s 16m..960m 16h... => 00:00:00 */
    if (ft) fprintf(ft,"%3d %20.16f %20.16f %02ld:%02ld:%02ld\n",
                    nr,(double)a,(double)b,t/3600,(t/60)%60,t%60);
    if (fb) fwrite(&a,sizeof(zahl),1,fb);
    if (fb) fwrite(&b,sizeof(zahl),1,fb);
    return;
}

/* restore tri-diag */
int loadtri(zahl *a, zahl *b, int n){ /* lade Tridiagonalmatrixelemente */
    FILE *f; int last=0;
    outtri(-1,0,0);
    f=fopen("tmp/tri.dat","rb");
    if(!f){E0("fopen(tmp/tri.dat)");return 0;}
    while(!feof(f) || last>=n){
      if(fread(a+last,sizeof(zahl),1,f)!=1)break;
      if(fread(b+last,sizeof(zahl),1,f)!=1)break;
      last++;
    }
    fclose(f);
    printf(" loadtri=%d",last);
    /* ToDo: call last times outtri */
    return last;
}

